#include <elapsedMillis.h>		// library voor tijdsfunkties

/*

Sturing Seinen met Arduino
Arduino ATmega2560
De Nil - 9 juni 2018

wijziging:

Laatste upload: 10 juli 2018

Werking Sein 4:
-druk op rood = rood sein
-druk op wit = wit + rood sein
-druk op geel = rood uit, wit uit, dubbel geel aan, balk 1" na bevel geel, snelheid 2" na bevel geel

Werking Sein 1, Sein 2 en Sein 3
-druk op rood = rood sein
-druk op wit = wit + rood sein
-druk op geel = dubbel geel sein
-druk op groen = groen sein

werking dwergsein Sein 5:
-druk op groen = groen
-druk op rood = rood

*/
//***************************************************************************************************************

#include <elapsedMillis.h>
#include <ctype.h>

// Variabelen voor ingangen (drukknoppen):
//
//Sein 4:
 int DrukknopSein4_Rood = 2;
 int DrukknopSein4_Wit = 3;
 int DrukknopSein4_Geel = 4;

int IngangSein4_Rood = 0;
int IngangSein4_Wit = 0;
int IngangSein4_Geel = 0;

int StatusSein4_Balk = 0;
int StatusSein4_Snelheid = 0;

//Sein 1:
 int DrukknopSein1_Rood = 5;		//drukknop Sein 1 rood aan pen 5
 int DrukknopSein1_Wit = 6;
 int DrukknopSein1_Geel = 7;
 int DrukknopSein1_Groen = 8;

int IngangSein1_Rood = 0;			//variabele inlezen drukknop Sein 1 Rood
int IngangSein1_Wit = 0;
int IngangSein1_Geel = 0;
int IngangSein1_Groen = 0;

//Sein 2:
int DrukknopSein2_Rood = 9;			//drukknop Sein 2 rood aan pen 9
int DrukknopSein2_Wit = 10;
int DrukknopSein2_Geel = 11;
int DrukknopSein2_Groen = 12;

int IngangSein2_Rood = 0;			//variabele inlezen drukknop Sein 2 Rood
int IngangSein2_Wit = 0;
int IngangSein2_Geel = 0;
int IngangSein2_Groen = 0;

//Sein 3:
int DrukknopSein3_Rood = 14;
int DrukknopSein3_Wit = 15;
int DrukknopSein3_Geel = 16;
int DrukknopSein3_Groen = 17;

int IngangSein3_Rood = 0;
int IngangSein3_Wit = 0;
int IngangSein3_Geel = 0;
int IngangSein3_Groen = 0;

//Sein 5:
int DrukknopSein5_Groen = 20;
int DrukknopSein5_Rood = 21;

int IngangSein5_Groen = 0;
int IngangSein5_Rood = 0;


// Variabelen voor uitgangen (Leds Seinen):
//Sein 4:
const int Sein4_Rood = 35;
const int Sein4_Wit = 37;
const int Sein4_Geel = 39;
const int Sein4_Balk = 45;
const int Sein4_Snelheid = 43;

//Sein 1:
int Sein1_Rood = 30;
int Sein1_Wit = 32;
int Sein1_Geel = 34;
int Sein1_Groen = 36;

 //Sein 2:
int Sein2_Rood = 38;
int Sein2_Wit = 40;
int Sein2_Geel = 42;
int Sein2_Groen = 44;

 //Sein 3:
int Sein3_Rood = 46;
int Sein3_Wit = 48;
int Sein3_Geel = 50;
int Sein3_Groen = 52;

 //Sein 5:
int Sein5_Groen = 31;
int Sein5_Rood = 33; 

//**************************************************************************************************************
void setup()
{  
	Serial.begin(9600);								//communicatie met monitor voor debugging	

	// definiëren ingangen Sein 4:
	pinMode(DrukknopSein4_Rood, INPUT_PULLUP);		// ingang bij open drukknop = 1 door inwendige pullup-weerstand (alle drukknoppen zijn NO)
	pinMode(DrukknopSein4_Wit, INPUT_PULLUP);
	pinMode(DrukknopSein4_Geel, INPUT_PULLUP);

	// definiëren ingangen Sein 1:
	pinMode(DrukknopSein1_Rood, INPUT_PULLUP);		// ingang bij open drukknop = 1 door inwendige pullup-weerstand (alle drukknoppen zijn NO)
	pinMode(DrukknopSein1_Wit, INPUT_PULLUP);
	pinMode(DrukknopSein1_Geel, INPUT_PULLUP);
	pinMode(DrukknopSein1_Groen, INPUT_PULLUP);

	// definiëren ingangen Sein 2:
	pinMode(DrukknopSein2_Rood, INPUT_PULLUP);		// ingang bij open drukknop = 1 door inwendige pullup-weerstand (alle drukknoppen zijn NO)
	pinMode(DrukknopSein2_Wit, INPUT_PULLUP);
	pinMode(DrukknopSein2_Geel, INPUT_PULLUP);
	pinMode(DrukknopSein2_Groen, INPUT_PULLUP);

	// definiëren ingangen Sein 3:
	pinMode(DrukknopSein3_Rood, INPUT_PULLUP);		// ingang bij open drukknop = 1 door inwendige pullup-weerstand (alle drukknoppen zijn NO)
	pinMode(DrukknopSein3_Wit, INPUT_PULLUP);
	pinMode(DrukknopSein3_Geel, INPUT_PULLUP);
	pinMode(DrukknopSein3_Groen, INPUT_PULLUP);

	// definiëren ingangen Sein 5:
	pinMode(DrukknopSein5_Groen, INPUT_PULLUP);		// ingang bij open drukknop = 1 door inwendige pullup-weerstand (alle drukknoppen zijn NO)
	pinMode(DrukknopSein5_Rood, INPUT_PULLUP);
	

	// definiëren uitgangen Sein 4:
	pinMode(Sein4_Rood, OUTPUT);
	pinMode(Sein4_Wit, OUTPUT);
	pinMode(Sein4_Geel, OUTPUT);
	pinMode(Sein4_Balk, OUTPUT);
	pinMode(Sein4_Snelheid, OUTPUT);

	// definiëren uitgangen Sein 1:
	pinMode(Sein1_Rood, OUTPUT);
	pinMode(Sein1_Wit, OUTPUT);
	pinMode(Sein1_Geel, OUTPUT);
	pinMode(Sein1_Groen, OUTPUT);

	// definiëren uitgangen Sein 2:
	pinMode(Sein2_Rood, OUTPUT);
	pinMode(Sein2_Wit, OUTPUT);
	pinMode(Sein2_Geel, OUTPUT);
	pinMode(Sein2_Groen, OUTPUT);

	// definiëren uitgangen Sein 3:
	pinMode(Sein3_Rood, OUTPUT);
	pinMode(Sein3_Wit, OUTPUT);
	pinMode(Sein3_Geel, OUTPUT);
	pinMode(Sein3_Groen, OUTPUT);

	// definiëren uitgangen Sein 5:
	pinMode(Sein5_Groen, OUTPUT);
	pinMode(Sein5_Rood, OUTPUT);	

	}

// Einde void Setup ***************************************************************************************************************

void loop()
{
 	// inlezen van de ingangen:
	IngangSein4_Rood = digitalRead(DrukknopSein4_Rood);
	IngangSein4_Wit = digitalRead(DrukknopSein4_Wit);
	IngangSein4_Geel = digitalRead(DrukknopSein4_Geel);

	IngangSein1_Rood = digitalRead(DrukknopSein1_Rood);
	IngangSein1_Wit = digitalRead(DrukknopSein1_Wit);
	IngangSein1_Geel = digitalRead(DrukknopSein1_Geel);
	IngangSein1_Groen = digitalRead(DrukknopSein1_Groen);

	IngangSein2_Rood = digitalRead(DrukknopSein2_Rood);
	IngangSein2_Wit = digitalRead(DrukknopSein2_Wit);
	IngangSein2_Geel = digitalRead(DrukknopSein2_Geel);
	IngangSein2_Groen = digitalRead(DrukknopSein2_Groen);

	IngangSein3_Rood = digitalRead(DrukknopSein3_Rood);
	IngangSein3_Wit = digitalRead(DrukknopSein3_Wit);
	IngangSein3_Geel = digitalRead(DrukknopSein3_Geel);
	IngangSein3_Groen = digitalRead(DrukknopSein3_Groen);

	IngangSein5_Groen = digitalRead(DrukknopSein5_Groen);
	IngangSein5_Rood = digitalRead(DrukknopSein5_Rood);

	//Serial.print("ingang drukknop Rood = ");	
	//Serial.println(IngangDrukknopSein1_Rood);

	// Sein 4:
	if (IngangSein4_Rood == 0)								// Sein 4 Rood gedrukt
	{
		Sein4(Sein4_Rood, Sein4_Wit, Sein4_Geel, Sein4_Balk, Sein4_Snelheid, 1, 0, 0, 0, 0);
	}
	if (IngangSein4_Wit == 0)								// Sein 4 Wit gedrukt
	{
		Sein4(Sein4_Rood, Sein4_Wit, Sein4_Geel, Sein4_Balk, Sein4_Snelheid, 1, 1, 0, 0, 0);
	}
	if (IngangSein4_Geel == 0)
	{
		//eerst de balk bovenop het sein
		Sein4(Sein4_Rood, Sein4_Wit, Sein4_Geel, Sein4_Balk, Sein4_Snelheid, 0, 0, 0, 1, 0);
		delay(2000);
		//dan de snelheidsaanduiding:
		Sein4(Sein4_Rood, Sein4_Wit, Sein4_Geel, Sein4_Balk, Sein4_Snelheid, 0, 0, 0, 1, 1);
		delay(2000);
		//dan gele leds:
		Sein4(Sein4_Rood, Sein4_Wit, Sein4_Geel, Sein4_Balk, Sein4_Snelheid, 0, 0, 1, 1, 1);
	}

	// Sein 1:

	if (IngangSein1_Rood == 0 )							//Sein 1 Rood gedrukt			
		{
		//Serial.print("drukknop Rood 11 = ");
		//Serial.println(IngangSein1_Rood);
			Sein(Sein1_Rood, Sein1_Wit, Sein1_Geel, Sein1_Groen, 1, 0, 0,0);
		}
	if (IngangSein1_Wit == 0)								//Sein 1 Wit gedrukt
		{
			Sein(Sein1_Rood, Sein1_Wit, Sein1_Geel, Sein1_Groen, 1, 1, 0, 0);
		}
	if (IngangSein1_Geel == 0)							// Sein 1 Geel gedrukt
		{
			Sein(Sein1_Rood, Sein1_Wit, Sein1_Geel, Sein1_Groen, 0, 0, 1, 0);
		}
	if (IngangSein1_Groen == 0)							// Sein 1 Groen gedrukt
		{
			Sein(Sein1_Rood, Sein1_Wit, Sein1_Geel, Sein1_Groen, 0, 0, 0, 1);
		}

	// Sein 2:

	if (IngangSein2_Rood == 0)							// Rood gedrukt			
	{
		//Serial.print("drukknop Rood 11 = ");
		//Serial.println(IngangSein1_Rood);
		Sein(Sein2_Rood, Sein2_Wit, Sein2_Geel, Sein2_Groen, 1, 0, 0, 0);
	}
	if (IngangSein2_Wit == 0)							// Wit gedrukt
	{		
		Sein(Sein2_Rood, Sein2_Wit, Sein2_Geel, Sein2_Groen, 1, 1, 0, 0);
	}
	if (IngangSein2_Geel == 0)							// Geel gedrukt
	{		
		Sein(Sein2_Rood, Sein2_Wit, Sein2_Geel, Sein2_Groen, 0, 0, 1, 0);
	}
	if (IngangSein2_Groen == 0)							// Groen gedrukt
	{		
		Sein(Sein2_Rood, Sein2_Wit, Sein2_Geel, Sein2_Groen, 0, 0, 0, 1);
	}


	// Sein 3:

	if (IngangSein3_Rood == 0)							// Rood gedrukt			
	{
		//Serial.print("drukknop Rood 11 = ");
		//Serial.println(IngangSein1_Rood);
		Sein(Sein3_Rood, Sein3_Wit, Sein3_Geel, Sein3_Groen, 1, 0, 0, 0);
	}
	if (IngangSein3_Wit == 0)							// Wit gedrukt
	{
		Sein(Sein3_Rood, Sein3_Wit, Sein3_Geel, Sein3_Groen, 1, 1, 0, 0);
	}
	if (IngangSein3_Geel == 0)							// Geel gedrukt
	{
		Sein(Sein3_Rood, Sein3_Wit, Sein3_Geel, Sein3_Groen, 0, 0, 1, 0);
	}
	if (IngangSein3_Groen == 0)							// GRoen gedrukt
	{
		Sein(Sein3_Rood, Sein3_Wit, Sein3_Geel, Sein3_Groen, 0, 0, 0, 1);
	}

	// Sein 5:

	if (IngangSein5_Groen == 0)								// groen gedrukt			
	{		
		Sein5(Sein5_Groen, Sein5_Rood, 1, 0);
	}
	if (IngangSein5_Rood == 0)							// rood gedrukt
	{
		Sein5(Sein5_Groen, Sein5_Rood, 0, 1);
	}

}

// Einde void Loop  **************************************************************************************************************

void Sein4(int Rood,int Wit, int Geel, int Balk, int Snelheid, boolean WaardeRood, boolean WaardeWit, boolean WaardeGeel, boolean WaardeBalk, boolean WaardeSnelheid)

{
	digitalWrite(Rood,WaardeRood);
	digitalWrite(Wit, WaardeWit);
	digitalWrite(Geel, WaardeGeel);
	digitalWrite(Balk, WaardeBalk);
	digitalWrite(Snelheid, WaardeSnelheid);
}

// Einde void Sein4 ************************************************************************************************************

void Sein(int Rood, int Wit, int Geel, int Groen, boolean WaardeRood, boolean WaardeWit, boolean WaardeGeel, boolean WaardeGroen)

{
	digitalWrite(Rood, WaardeRood);
	digitalWrite(Wit, WaardeWit);
	digitalWrite(Geel, WaardeGeel);
	digitalWrite(Groen, WaardeGroen);	
}

// Einde void Sein *************************************************************************************************************

void Sein5(int Wit, int Blauw, boolean WaardeWit, boolean WaardeBlauw)
{
	digitalWrite(Wit, WaardeWit);
	digitalWrite(Blauw, WaardeBlauw);
}

// Einde void Sein 5 ***********************************************************************************************************
